unit FFT_Func;

interface

uses math,TeEngine, Series, TeeProcs, Chart,sysutils;

procedure sgl(seriesin,seriesout:TChartSeries;pt,ps,func:smallint);
function FFT(var x, y:array of double;var nn:integer;nf, ii: integer): integer;
procedure FFTQuad(seriesin,seriesout: TChartSeries;max:integer;p:boolean);
procedure AverageNoise(seriesspt,seriesnoise: TChartSeries);
function win(seriesin,seriesout: TChartSeries;p:integer;k:real):string;

  type  General_Report=record
   dc_comp, max_value, avr_noise, s_noise : integer;
   end;

const h=1e-4;
      keys = '1234567890*#abcd';
      dtmf1: array[1..16]of integer =(697,697,697,770,770,770,852,852,852,941,941,941,697,770,852,941);
      dtmf2: array[1..16]of integer =(1209,1336,1477,1209,1336,1477,1209,1336,1477,1336,1209,1477,1633,1633,1633,1633);
      //
var   GR: General_Report;
      fftcnt: integer= 2048;

implementation

//--- ---
// --
function langr(seriesin:TChartSeries;p:extended):extended;
label 1;
var i,j,n:integer;c,d,s:extended;
begin
 s:=0;
 n:=seriesin.xValues.Count;
 if p=seriesin.xValues[0] then begin result:=seriesin.yValues[0];goto 1;end;
 for j:=1 to n do
  begin
   c:=1;
   for i:=1 to n do
    begin
     d:=seriesin.XValues[j-1]-seriesin.XValues[i-1];
     if i=j then d:=p-seriesin.xValues[j-1];
     if d=0 then begin result:=seriesin.yValues[i-1];goto 1;end;
     c:=c*(p-seriesin.xValues[i-1])/d;
    end;
   s:=s+c*seriesin.yValues[j-1];
  end;
 //
 result:=s;
 1: ;
end;
// - -
function logreg(seriesin:TChartSeries;p:real):real;
var i,j,n:integer;a,b,c,d,e,f,k:real;
begin
 n:=seriesin.xValues.Count-1;
 a:=0;b:=0;b:=0;d:=0;

 for i:=0 to n do
  begin
   a:=a+log10(seriesin.xValues[i]+h);
   b:=b+2*log10(seriesin.xValues[i]+h);
   c:=c+seriesin.yValues[i];
   d:=d+seriesin.yValues[i]*log10(seriesin.xValues[i]+h);
  end;
 e:=(n+1)*b-a*a;
 f:=c*b-d*a;
 k:=(n+1)*d-a*c;
 f:=f/(e+h);
 k:=k/(e+h);
 //
 result:=f+k*log10(p);
end;

//  
function LinReg(serin:tchartseries;xin:real):real;
var i,n:integer;
    a,r,c,d,k,b:real;
begin
 n:=serin.xValues.Count;
 a:=0; b:=0; c:=0; d:=0; r:=0; k:=0;
 for i:=0 to n-1 do begin
  a:=a+serin.XValue[i];
  r:=b+serin.YValue[i];
  c:=c+sqr(serin.XValue[i]);
  d:=d+serin.XValue[i]*serin.YValue[i];
 end;
 k:=(a*r-d*n)/(sqr(a)-n*c+h);
 b:=(r-k*a)/(h+n);
 result:=b+k*xin;
end;
//  
function hyper(serin:tchartseries;xin:real):real;
var i,n:integer;
    a,b,c,d,e,f,k:real;
begin
 n:=serin.xValues.Count;
 a:=0; b:=0; c:=0; d:=0;
 for i:=0 to n-1 do begin
  a:=a+1/(serin.xvalue[i]+h);
  b:=b+1/(sqr(serin.XValue[i])+h);
  c:=c+serin.YValue[i];
  d:=d+serin.YValue[i]/(serin.XValue[i]+h);
 end;
 e:=n*b-sqr(a);
 f:=c*b-d*a;
 k:=n*d+a*c;
 f:=f/(h+e);
 k:=k/(e+h);
 result:=f+k/(xin+h);
end;
//  
function step(serin:tchartseries;xin:real):real;
var i,n:integer;
    a,b,c,d,e,f:real;
begin
 n:=serin.xValues.Count;
 a:=0; b:=0; c:=0; d:=0;
 for i:=0 to n-1 do begin
  a:=a+ln(serin.xvalue[i]+h);
  try b:=b+ln(serin.yValue[i]+h);except end;
  c:=c+ln(serin.xValue[i]+h)*ln(serin.YValue[i]+h);
  d:=d+sqr(ln(serin.XValue[i]+h));
 end;
 e:=(a*b-n*c)/(sqr(a)-n*d+h);
 f:=exp((b-e*a)/(n+h));
 result:=f*power(xin,e);
end;
//  
function pokaz(serin:tchartseries;xin:real):real;
var i,n:integer;
    a,b,c,d,e,f,k:real;
begin
 n:=serin.xValues.Count;
 a:=0; b:=0; c:=0; d:=0;
 for i:=0 to n-1 do begin
  a:=a+serin.xvalue[i];
  b:=b+sqr(serin.xValue[i]);
  try c:=c+log10(serin.yValue[i]+h);except end;
  d:=d+serin.XValue[i]*log10(serin.YValue[i]+h);
 end;
 e:=n*b-sqr(a);
 f:=c*b-d*a;
 k:=n*d-a*c;
 f:=power(10,f/(h+e));
 k:=power(10,k/(h+e));
 result:=f*power(k,xin);
end;
//  
function expreg(serin:tchartseries;xin:real):real;
var i,n:integer;
    a,b,c,d,e,f:real;
begin
 n:=serin.xValues.Count;
 a:=0; b:=0; c:=0; d:=0;
 for i:=0 to n-1 do begin
  a:=a+serin.xvalue[i];
  b:=b+ln(serin.yValue[i]+h);
  c:=c+sqr(serin.xValue[i]);
  d:=d+serin.XValue[i]*ln(serin.yValue[i]+h);
 end;
 e:=(a*b-n*d)/(sqr(a)-n*c+h);
 f:=exp((b-e*a)/(h+n));
 result:=f*exp(xin*e);
end;
//  
function parab(serin:tchartseries;xin:real):real;
var i,n:integer;
    b,c,d,e,q,k,l,b2,b1,b0,f,m,p,r,s:real;
begin
 n:=serin.xValues.Count;
 b:=0; c:=0; d:=0;
 for i:=0 to n-1 do begin
  b:=b+serin.XValue[i];
  c:=c+sqr(serin.XValue[i]);
  f:=f+power(serin.xvalue[i],3);
  m:=m+power(serin.XValue[i],4);
  p:=p+serin.YValue[i];
  r:=r+serin.XValue[i]*serin.YValue[i];
  s:=s+serin.YValue[i]*sqr(serin.XValue[i]);
 end;
 d:=b;
 e:=c;
 k:=c;
 l:=f;
 q:=d/(h+n);
 e:=e-q*b;
 f:=f-q*c;
 r:=r-q*p;
 q:=k/(h+n);
 l:=l-q*b;
 m:=m-q*c;
 s:=s-q*p;
 q:=l/(h+e);
 b2:=(s-r*q)/(m-f*q+h);
 b1:=(r-f*b2)/(e+h);
 b0:=(p-b*b1-c*b2)/(n+h);
 result:=b0+b1*xin+b2*sqr(xin);
end;
//------------------------------------------//

//
procedure sgl(seriesin,seriesout:TChartSeries;pt,ps,func:smallint);
var i,j,n:integer;k:real;
    ser:tchartseries;
begin
 j:=0;
 if Seriesin.xValues.count=0 then exit;
 //
 n:=seriesin.XValues.count-1;
 ser:=tlineseries.Create(ser);
 //
 for i:=0 to n do
  begin
   inc(j);
   ser.AddXY(seriesin.XValues[i],seriesin.yvalues[i]);
   if j=pt then
    begin
     try
     case func of
      0: seriesout.AddXY(seriesin.XValue[i-(j div 2)],ps+langr(ser,seriesin.XValue[i-(j div 2)]));
      1: seriesout.AddXY(seriesin.XValue[i-(j div 2)],ps+logreg(ser,seriesin.XValue[i-(j div 2)]));
      2: seriesout.AddXY(seriesin.XValue[i-(j div 2)],ps+linreg(ser,seriesin.XValue[i-(j div 2)]));
      3: seriesout.AddXY(seriesin.XValue[i-(j div 2)],ps+step(ser,seriesin.XValue[i-(j div 2)]));
      4: seriesout.AddXY(seriesin.XValue[i-(j div 2)],ps+hyper(ser,seriesin.XValue[i-(j div 2)]));
      5: seriesout.AddXY(seriesin.XValue[i-(j div 2)],ps+expreg(ser,seriesin.XValue[i-(j div 2)]));
      6: seriesout.AddXY(seriesin.XValue[i-(j div 2)],ps+parab(ser,seriesin.XValue[i-(j div 2)]));
      7: seriesout.AddXY(seriesin.XValue[i-(j div 2)],ps+pokaz(ser,seriesin.XValue[i-(j div 2)]));
     end;except end;
     ser.Clear;j:=0;
    end;
  end;
 //
 ser.Destroy;
end;
//------------------------------------------//



//---C
//->
//x-re, y-im, nn-- ,nf-  -,ii-no use)
function FFT(var x, y:array of double;var nn:integer;nf, ii: integer): integer;
var c,s,t1,t2,t3,t4,u1,u2,u3,z,a0,a1,a2,a3,w:double;
i,j,p,rt,l,ll,m,m1,k:integer;
begin
rt:=1;
nn:=nn div 2;
while rt<nn do
begin
rt:=rt*2;
end;

nn:=rt*2;

z:=2*pi/nn;

case nf of
//---~67dB-----
1:begin
   a0:=0.42323;
   a1:=0.49755;
   a2:=0.07922;
   a3:=0;
  end;
2:begin
   a0:=0.44959;
   a1:=0.49364;
   a2:=0.05677;
   a3:=0;
  end;
//---~92dB-----
3:begin
   a0:=0.35875;
   a1:=0.48829;
   a2:=0.14128;
   a3:=0.01168;
  end;
//---~72dB-----
4:begin
   a0:=0.40217;
   a1:=0.49703;
   a2:=0.09392;
   a3:=0.00183;
  end;
5:begin
   a0:=1;
   a1:=0;
   a2:=0;
   a3:=0;
  end;
end;

for i:=0  to nn-1 do
begin
 w:=a0-a1*cos(z*i)+a2*cos(z*2*i)+a3*cos(z*3*i);
 x[i]:=x[i]*w;
 y[i]:=y[i]*w;
end;
//-------------------------------------------
ll:=nn;
M:=nn div 2;
M1:=Nn-1;
while ll>=2 do
 begin
  l:=ll div 2;
  u1:=1;
  u2:=0;
  t1:=PI/l;
  c:=cos(t1);
  s:=(-1)*ii*sin(t1);
  for j:=0  to l-1 do
   begin
    i:=j;
    while i<nn do
     begin
      p:=i+l;
      t1:=x[i]+x[p];
      t2:=y[i]+y[p];
      t3:=x[i]-x[p];
      t4:=y[i]-y[p];
      x[p]:=t3*u1-t4*u2;
      y[p]:=t4*u1+t3*u2;
      x[i]:=t1;
      y[i]:=t2;
      i:=i+ll;
     end;
    u3:=u1*c-u2*s;
    u2:=u2*c+u1*s;
    u1:=u3;
   end;
  ll:=ll div 2;

 end;
 j:=0;

 for i:=0  to m1-1 do
  begin
   if i>j then
    begin
     t1:=x[j];
     t2:=y[j];
     x[j]:=x[i];
     y[j]:=y[i];
     x[i]:=t1;
     y[i]:=t2;
    end;
 k:=m;

 while j>=k do
  begin
   j:=j-k;
   k:=k div 2;
  end;
 j:=j+k;
end;

end;

//-----
procedure FFTQuad(seriesin,seriesout: TChartSeries;max:integer;p:boolean);
var a,b:array of double;
 i,k:integer;
 d:real;
 // 
 //seriesp: TChartSeries;
begin
 //   -     
 //k:=seriesin.XValues.Count-1;
 //for i:=0 to k do
  //try seriesp.AddXY(i,langr(seriesin,i));except end;
 //seriesin.Assign(seriesp);

 //max- 
 i:=0;
 if Seriesin.yValues.count =0 then exit;
  k:= Seriesin.YValues.Count;
 while (k>1)and(power(2,i)<max) do
  begin
   k:=k div 2;
   inc(i);
  end;

 k:=ceil(power(2,i));
 SetLength(a,k);
 SetLength(b,k);

 for i:=0  to k-1 do
 begin

  a[i]:=  Seriesin.YValue[i];
  b[i]:=0;
 end;

 if p then FFT(a,b,k,4,1)
  else FFT(a,b,k,5,1);// 

 for i:=0  to k div 2-1 do
 begin
  d:=sqrt(a[i]*a[i]+b[i]*b[i]);
  d:=20*log10(d/k+0.000001)-30;
  seriesout.Add(d);
 end;
end;

//-----Noise
procedure AverageNoise(seriesspt,seriesnoise: TChartSeries);
var i,n,avr,X,Xstart,Xend,sum,s_n: integer;
    dc,max: real;
begin
 if Seriesspt.yValues.count=0 then exit;
 //
 X:= trunc(seriesspt.YValues.Count);
 Xstart:= trunc(X*0.05);
 Xend:= trunc(X*0.95);

 dc:= -1000;
 for  i:= 0  to Xstart-1 do
  if seriesspt.YValue[i]>dc then
   begin
    dc:= seriesspt.YValue[i];
   end;

 max:=-1000;
 for i:= Xstart to Xend do
  if (seriesspt.YValue[i])> max then
   begin
    max:= seriesspt.YValue[i];
    n:= i;
   end;

 sum:=0;
 for i := Xstart to Xend do
  begin
   if (i<n-0.05*X) or (i>n+0.05*X) then
    begin
     sum:= trunc(seriesspt.YValue[i])+sum;
    end;
  end;

 n:= trunc(X*0.8);
 avr:= sum div n;
 s_n:= avr - trunc(max);
 for  i := 0 to X-1 do
  begin
   seriesnoise.Add(avr);
  end;
 //  
 GR.dc_comp:= trunc(dc);
 GR.max_value:= trunc(max);
 GR.avr_noise:= avr;
 GR.s_noise:= s_n;
 //
end;

function stat(a,b,w,c,d:real;i:integer):string;
const h=1e-6;
var m1,m2,m3,m4,d1,d2,k,m,l,a1,e,u3,u4:real;
    s:string;
begin
 m1:=a/i;
 m2:=b/i;
 m3:=c/i;
 m4:=d/i;
 //
 d1:=m2-m1;
 d2:=d1*i/(i-1);
 k:=h+m3-(3*m1*m2)+(2*m1*m1*m1);
 w:=m1*m1;
 l:=h+m4-(4*m1*m3)+(6*w*m2)-(3*w*w);
 try
 a1:=k/power(d1,3/2);
 e:=l/(d1*d1)-3;
 u3:=sqrt(6*(i-1)/((i+1)*(i+3)));
 u4:=sqrt(24*(i-2)*(i-3)/(i+3)/(i+5)/((i-1)*(i-1)));
 except end;
 //
 if ((a1<u3/2)and(e<u4/2)) then s:=' - .'
  else s:=' - .';
 //
 result:='C..= '+floattostrf(m1,ffgeneral,7,2)+chr(13)+
  ' .= '+floattostrf(d1,ffgeneral,7,2)+chr(13)+
  ' .= '+floattostrf(d2,ffgeneral,7,2)+chr(13)+
  '- = '+floattostrf(a1,ffgeneral,7,2)+chr(13)+
  ' = '+floattostrf(e,ffgeneral,7,2)+chr(13)+
  s;
end;
//-----WIN
function win(seriesin,seriesout: TChartSeries;p:integer;k:real):string;
const h=1e-12;
var y,x,i,ii:integer;
    //
    z,a,b,w,c,d:real;
begin
 if Seriesin.yValues.count =0 then exit;
 //
 y:= trunc(seriesin.YValues.Count);
 x:= trunc(seriesin.XValues.Count);
 // 
 z:=0;ii:=0;a:=0;b:=0;c:=0;d:=0;w:=0;

 //
 for i:=0 to y-1 do
  begin
   //
   a:=a+seriesin.YValues[i];
   b:=b+(seriesin.YValues[i]*seriesin.YValues[i]);
   w:=power(seriesin.YValues[i],3);
   c:=c+w;
   d:=d+w*seriesin.YValues[i];

   //
   case p of
    0: begin//  V=V*(1-K)+V*K
        if k>1 then k:=k-trunc(k);
        z:=seriesin.YValues[i]*(1-k)+(z*k);
       end;
    1: begin // .  V=(Vo+V)/K
        z:=(seriesin.YValues[i]+z)/trunc(k);
        inc(ii);
       end;
    2: begin // . 
        z:=power(1/(trunc(k)+h),seriesin.YValues[i]*z);
        inc(ii);
       end;
    3: begin // . 
        z:=trunc(k)/((1/(seriesin.YValues[i]+h))+(1/(z+h)));
        inc(ii);
       end;
    //-
    5: //lg-
       z:=log10(h+abs(seriesin.YValues[i]));
    6: //ln-
       z:=ln(h+abs(seriesin.YValues[i]));
    7: //exp-
       z:=exp(seriesin.YValues[i]);
    8: //^2-
       z:=seriesin.YValues[i]*seriesin.YValues[i];
    9: //^1/2-
       z:=sqrt(seriesin.YValues[i]);
    10: //^-1-
       z:=1/seriesin.YValues[i];

   end;
   // 
   if (((p=1)or(p=2)or(p=3))and(ii=trunc(k))) then begin //
    seriesout.Addxy(seriesin.XValues[i],z);
    z:=0;ii:=0;end;
   if p<>1 then                   //
    seriesout.Addxy(seriesin.XValues[i],z);
  end;
 //
 //result:=stat(a,b,w,c,d,y);
end;

end.
