//------------------------------------------
//Sound in record
//   WAV - MP3
// +  
// +  WAV - MP3
//Author:   
//E-mail: raxp@mail.zp.ua
//C : -
//------------------------------------------

unit rec;

interface

uses windows,recunit,mmsystem,sysutils,classes,ExtCtrls,series,fft_func,math;

type
  TWaveHeaderChank = record     // () 
    wFormatTag     : Smallint;
    wChannels      : WORD;
    wSamplesPerSec : Cardinal;
    wAvgBytesPerSec: Cardinal;
    wBlockAlign    : WORD;
    wBitsPerSample : WORD;
    wcbSize        : WORD;
  end;

 { TWaveResult = record
    ident1: array[0..3] of Char;      // Must be "RIFF"
    len: DWORD;                       // Remaining length after this header 
    ident2: array[0..3] of Char;      // Must be "WAVE" 
    ident3: array[0..3] of Char;      // Must be "fmt "
    reserv: DWORD;                    // Reserved 4 bytes 
    wFormatTag: Word;                 // format type 
    nChannels: Word;                  // number of channels (i.e. mono, stereo, etc.) 
    nSamplesPerSec: DWORD;            //sample rate 
    nAvgBytesPerSec: DWORD;           //for buffer estimation 
    nBlockAlign: Word;                //block size of data 
    wBitsPerSample: Word;             //number of bits per sample of mono data 
    cbSize: Word;                     //the count in bytes of the size of 
    ident4: array[0..3] of Char;      //Must be "data"
    Data           : TMemoryStream;
end; }
  TWaveResult = record          // 
    ERROR          : WORD;      //   
    wAvgBytesPerSec: Cardinal;  // Wav 
    wBitsPerSample : WORD;
    wChannels      : WORD;
    Data           : TMemoryStream;
    wSamplePerSec  : word;
end;

type //wave- head
 TWaveHeader = record
  Marker1:        Array[0..3] of Char;
  BytesFollowing: LongInt;
  Marker2:        Array[0..3] of Char;
  Marker3:        Array[0..3] of Char;
  Fixed1:         LongInt;
  FormatTag:      Word;
  Channels:       Word;
  SampleRate:     LongInt;
  BytesPerSecond: LongInt;
  BytesPerSample: Word;
  BitsPerSample:  Word;
  Marker4:        Array[0..3] of Char;
  DataBytes:      LongInt;
end;

type //wave- ind
  TData16 = array [0..127] of smallint;
  PData16 = ^TData16;
  TPointArr = array [0..127] of TPoint;
  PPointArr = ^TPointArr;

type
 PWR = ^TWR;
 TWR = class(TWaveRecorder)
 public
  name:string;
  //procedure ProcessBuffer(uMsg: Word; P: Pointer;n:integer; dwParam1: dword);override;
 end;

 function ReadWave(FileName: AnsiString) : TWaveResult;
 procedure wcard;
 procedure inirec(f: string;rate: integer;chan,bits: smallint); //rec wav-
 //procedure inirec2(f:string;rate: integer;chan,bits: smallint); //rec mp3-
 //procedure encwavmp3(wavname,mp3name:string); //wav mp3-

const noError            = 0;
      ReadError          = 1;
      HeaderError        = 2;
      DataError          = 3;
      FileCorrupt        = 4;
      IncorectFileFormat = 5;

var ser1,ser2,inwav,outwav: TfastLineSeries;
    dtmf_sig: string;
    //API- WAVE
    header: TWaveFormatEx;
    //vis_ir: timage;
    WaveHeader: TWaveHeader;
    fOut      : file of byte;
    n1,n2,sz,
    gChannels,gBitsPerSample,gRate,WaveDataLength,device,bufsize: integer;
    WaveData1 : PChar;
    WaveData2 : PChar;
    wfx       : TWaveFormatEx;
    wh1,wh2,
    BufHead1,BufHead2: TWaveHdr;
    hwi1,hwi2 : HWAVEIN;
    adr1,adr2 : pWaveHdr;
    stp1: boolean = FALSE; stp2: boolean = FALSE;
    hBuf: THandle;
    pnt : PPointArr;
    //flic-
    cnt_:boolean;

implementation
uses unit1;


{function ReadWave(FileName: AnsiString) : TWaveResult;
const
  riff = 'RIFF'; 
  wave = 'WAVE';
var f: TFileStream;
    w: TWaveHeader;
begin
 if not FileExists(Filename) then exit;

 try
  f:= TFileStream.create(Filename, fmOpenRead);
  f.Read(w, Sizeof(w));
  if w.ident1 <> riff then exit;
  if w.ident2 <> wave then exit;
 finally f.free end;
 Result:= w
end;  }
function ReadWave(FileName: AnsiString) : TWaveResult;
var
  f             : TFileStream;
  wFileSize     : Cardinal;
  wChankSize    : Cardinal;
  ID            : array[0..3] of Char;
  Header        : TWaveHeaderChank;
  RealFileSize  : Cardinal;

Begin
  FillChar(Result, SizeOf(Result), 0);
  Try
    f := TFileStream.Create(FileName, fmOpenRead);
    f.Seek(0, soFromBeginning);
    f.ReadBuffer(ID[0], 4);       //  
    if String(ID) <> 'RIFF' then Begin      //  
        Result.ERROR := IncorectFileFormat;
        f.Free;
        exit;
    end;

    f.ReadBuffer(wFileSize, 4);   //  
    //////////////////////////
    //Form1.olog.Lines.Add('FileSize ' + intToStr(wFileSize));
    {if f.size <> (wFileSize + 8)  //   
    then                          //  (     
      Begin                       //)
        Result.ERROR := FileCorrupt;
        f.Free;
        exit;
      end; }
    f.ReadBuffer(ID[0], 4);
      //////////////////////////
      //Form1.olog.Lines.Add(String(ID));
    if String(ID) <> 'WAVE' then begin   //  
        Result.ERROR := IncorectFileFormat;
        f.Free;
        exit;
      end;
 
    wChankSize := 0;
    repeat                              //  
      f.Seek(wChankSize, soFromCurrent);//   
      f.ReadBuffer(ID[0], 4);           //  
        //////////////////////////
      //Form1.olog.Lines.Add(String(ID));
      f.ReadBuffer(wChankSize, 4);   //  
      if wChankSize > High(integer)  //    
      then                           //     
        Begin                        //  100
          Result.ERROR := DataError;
          f.Free;
          exit;
        end;
        //////////////////////////
        //Form1.olog.Lines.Add('chankSize ' + intToStr(wChankSize));
    until  (String(ID)='fmt ') or (String(ID)='data');
    if String(ID)='data'             //    
    then
      Begin
        Result.ERROR := HeaderError;
        f.Free;
        exit;
      end;
    f.ReadBuffer(Header, Min(wChankSize, SizeOf(TWaveHeaderChank))); // 
      //////////////////////////               //  
      //Form1.olog.Lines.Add('wFormatTag '     + intToStr(Header.wFormatTag));
      //Form1.olog.Lines.Add('wChannels '      + intToStr(Header.wChannels));
      //Form1.olog.Lines.Add('wSamplesPerSec ' + intToStr(Header.wSamplesPerSec));
       result.wSamplePerSec:= Header.wSamplesPerSec;
      //Form1.olog.Lines.Add('wBlockAlign '    + intToStr(Header.wBlockAlign));
      //Form1.olog.Lines.Add('wBitsPerSample ' + intToStr(Header.wBitsPerSample));

    if wChankSize > SizeOf(TWaveHeaderChank)  //     
    then                                      //    
      f.Seek(wChankSize - SizeOf(TWaveHeaderChank), soFromCurrent);

    //if wChankSize >= SizeOf(TWaveHeaderChank) //     
    //then messagebox(0,'','',mb_ok);
      //////////////////////////
        //Form1.olog.Lines.Add('wcbSize '        + intToStr(Header.wcbSize));
    wChankSize := 0;
    repeat                              //  
      f.Seek(wChankSize, soFromCurrent);//   
      f.ReadBuffer(ID[0], 4);           //  
        //////////////////////////
      //Form1.olog.Lines.Add(String(ID));
      f.ReadBuffer(wChankSize, 4);      //   
        //////////////////////////
      //Form1.olog.Lines.Add('chankSize '    + intToStr(wChankSize));
    until  String(ID)='data';

    Result.ERROR           := noError;               //  
    Result.wAvgBytesPerSec := Header.wAvgBytesPerSec;
    Result.wBitsPerSample  := Header.wBitsPerSample;
    Result.wChannels       := Header.wChannels;
    Result.Data := TMemoryStream.Create;
    Result.Data.Seek(0, soFromBeginning);
    Result.Data.Size := wChankSize;                 //   
    f.ReadBuffer(Result.Data.Memory^, wChankSize);  //   
  Except
    Result.ERROR := ReadError;
  end;
  f.Free
end;
//===============

//======= record
// 
procedure MakeHeader;
begin
 with WaveHeader do
  begin
   Marker1       := 'RIFF';
   BytesFollowing:= n1 + 36;
   Marker2       := 'WAVE';
   Marker3       := 'fmt ';
   Fixed1        := 16;
   FormatTag     := 1;
   SampleRate    := gRate;
   Channels      := gChannels;
   BytesPerSecond:= gChannels;
   BytesPerSecond:= WaveHeader.BytesPerSecond * gRate;
   BytesPerSecond:= WaveHeader.BytesPerSecond * gBitsPerSample;
   BytesPerSecond:= WaveHeader.BytesPerSecond div 8;
   BytesPerSample:= gChannels * gBitsPerSample div 8;
   BitsPerSample := gBitsPerSample;
   Marker4       := 'data';
   DataBytes     := n1;
  end;
 Reset(fOut);
 BlockWrite(fOut,WaveHeader,sizeof(TWaveHeader))
end;
//= systimer1 =
procedure waveInProc1(hwi: HWAVEIN; uMsg,dwInstance,
                     dwParam1,dwParam2: DWORD);stdcall;
var temp: pWaveHdr;
    recorded: integer;
begin
 if (uMsg=WIM_CLOSE) then begin
  MakeHeader;
  CloseFile(fOut);
  GlobalFree(integer(WaveData1)); GlobalFree(integer(WaveData2))
 end;

 if (uMsg=WIM_DATA) then begin
  temp:= adr1;
  if adr1= @wh1 then adr1:= @wh2
   else adr1:= @wh1;
  //
  if stp1 then waveInAddBuffer(hwi,adr1,sizeof(TWaveHdr));
  recorded:= adr1.dwBytesRecorded;
  //
  BlockWrite(fOut,(temp.lpData)^,recorded);
  n1:=n1+recorded;
  sz:=round(n1/1024);
 end else Exit
end;
//
procedure inirec(f: string;rate: integer;chan,bits: smallint);
var WaveNums  : integer;
    waveInCaps: TWaveInCaps;
begin
 stp1:= not stp1;
 //opt-
 device:=0; gRate:= rate; gChannels:= chan; gBitsPerSample:= bits;
 WaveNums:=waveInGetNumDevs;
 if WaveNums>0 then waveInGetDevCaps(0,@WaveInCaps,sizeof(TWaveInCaps));
 //  -1/2 
 WaveDataLength:=gRate*gChannels*gBitsPerSample div 8;
 WaveDataLength:=WaveDataLength div 2;
 //
 if stp1 then begin
  n1:=0;
  WaveData1:=PChar(GlobalAlloc(GMEM_FIXED or GMEM_NOCOMPACT or GMEM_NODISCARD, WaveDataLength));
  WaveData2:=PChar(GlobalAlloc(GMEM_FIXED or GMEM_NOCOMPACT or GMEM_NODISCARD, WaveDataLength));
  AssignFile(fOut,f);
  ReWrite(fOut);
  //  -
  BlockWrite(fOut,WaveHeader,sizeof(TWaveHeader));
  // -
  wfx.nChannels      := gChannels; //1 - , 2- 
  wfx.wFormatTag     := WAVE_FORMAT_PCM; // - PCM
  wfx.nSamplesPerSec := gRate; //sample rate, Hz
  wfx.wBitsPerSample := gBitsPerSample; // /
  wfx.nBlockAlign    := wfx.nChannels*wfx.wBitsPerSample div 8;
  wfx.nAvgBytesPerSec:= gRATE*wfx.nChannels*wfx.wBitsPerSample div 8;
  wfx.cbSize         := 0;
  //
  try waveInOpen(@hwi1,device,@wfx,integer(@waveInProc1),
                 0,CALLBACK_FUNCTION);
  except end;
  //-
  wh1.lpData :=WaveData1;
  wh1.dwBufferLength:=WaveDataLength*sizeof(byte);
  wh1.dwUser :=0;
  wh1.dwFlags:=0;
  wh2.lpData :=WaveData2;
  wh2.dwBufferLength:=WaveDataLength*sizeof(byte);
  wh2.dwUser :=0;
  wh2.dwFlags:=0;
  adr1:= @wh1;
  try
  waveInPrepareHeader(hwi1,@wh1,sizeof(TWaveHdr));
  waveInPrepareHeader(hwi1,@wh2,sizeof(TWaveHdr));
  except end;
  //1-   -
  try waveInAddBuffer(hwi1,@wh1,sizeof(TWaveHdr));
  except end;
  if waveInStart(hwi1)<>MMSYSERR_NOERROR then Exit
 end else begin
  waveInReset(hwi1);
  waveInClose(hwi1)
 end
end;
//=======

//======= ind
//= systimer2 =
procedure waveInProc2(hwi: HWAVEIN; uMsg,dwInstance,
                     dwParam1,dwParam2: DWORD);stdcall;
var i: integer;
    data16: PData16;
    h: integer;
    XScale, YScale: single;
    temp: pWaveHdr;
    //
    a,a1,a2,           //-
    f,f1,f2: double;   //-
begin
 if (uMsg=WIM_DATA) then begin
  temp:= adr2;
  if adr2= @bufhead1 then adr2:= @bufhead2
   else adr2:= @bufhead1;
  //
  if stp2 then WaveInAddBuffer(hwi,adr2,SizeOf(TWaveHdr));
  //
  data16:= PData16(temp.lpData);
  //graf-
  //h:= vis_ir.Height; //k:= abs(data16^[0]);
  //XScale:= vis_ir.Width / BufSize;
  //YScale:= h / (1 shl 16);

  try inwav.Clear; outwav.Clear;
  form1.series5.Clear;
  form1.series6.Clear;
  for i := 0 to BufSize - 1 do begin //-
   //pnt^[i]:= Point(round(i * XScale),round(h / 2 - data16^[i] * YScale));
   form1.series6.add(data16^[i]);
   inwav.add(data16^[i])
  end;
  FFTQuad(inwav,outwav,fftcnt,false);

  //  2-x   -----
  a1:= -1000;
  for i:= 0 to (outwav.YValues.Count)-1 do begin //
   a:= outwav.YValues[i];
   f:= i / (outwav.YValues.Count/2) * (header.nSamplesPerSec / 2);
   form1.series5.AddXY(f,a);
   if a > a1 then begin a1:= a; f1:= f end                  //  1-
  end;
  a2:= -1000;
  for i:= (outwav.YValues.Count)-1 downto 0 do begin
   a:= outwav.YValues[i];
   f:= i / (outwav.YValues.Count/2) * (header.nSamplesPerSec / 2);
   if (a > a2)and(a<>a1) then begin a2:= a; f2:= f end      //  2-
  end;
  //-
  dtmf_sig:= 'not';
  for i:= 1 to 16 do begin
   if (dtmf2[i]*0.98<f1)and(dtmf2[i]*1.02>f1)and  //1  >2
    (dtmf1[i]*0.98<f2)and(dtmf1[i]*1.02>f2)then begin
      dtmf_sig:= keys[i];
      break
     end;
   if (dtmf1[i]*0.98<f1)and(dtmf1[i]*1.02>f1)and  //1  >2
    (dtmf2[i]*0.98<f2)and(dtmf2[i]*1.02>f2)then begin
      dtmf_sig:= keys[i];
      break
     end;
  end;
  form1.CH.Title.Text.Strings[0]:= 'DTMF('+dtmf_sig+'):  ' +
                                   format('A1= %.2n',[a1])+ formatfloat(' [0 Hz]  ',f1) +
                                   format('A2= %.2n',[a2])+ formatfloat(' [0 Hz]',f2);

  //-----------------------------------

  {with vis_ir.Canvas do begin
   brush.Color:= 0;
   FillRect(ClipRect);
   pen.Color:= 16711680;//clblue;
   Polyline(Slice(pnt^, BufSize));
   font.Color:= 255;
   font.Name:= 'arial'; font.Size:= 5;
   cnt_:= not cnt_;
   if cnt_ then textout(0,0,'REC');//inttohex(k,4));
   font.Color:= 65280;
   textout(0,h-7,inttostr(sz)+' KB');
  end }
  //
  except end
 end else Exit
end;
//
procedure wcard;
const rbuf=7;
var BufLen: word;
    buf: pointer;
begin
 //vis_ir:= tmp;
 try
 //
 stp2:=not stp2;
 if stp2 then begin
  //vis_ir.Visible:=true;
  //vis_ir.Hint:= ' ...';
  //
  BufSize:= rbuf * 500 + 100;
  with header do begin
   wFormatTag:= WAVE_FORMAT_PCM;
   nChannels := 2;
   nSamplesPerSec:= 44100;
   wBitsPerSample:= 16;
   nBlockAlign:= nChannels * (wBitsPerSample div 8);
   nAvgBytesPerSec:= nSamplesPerSec * nBlockAlign;
   cbSize:= 0;
  end;
  WaveInOpen(Addr(hwi2), WAVE_MAPPER, addr(header),integer(@waveInProc2),
             0,CALLBACK_FUNCTION);
  BufLen:= header.nBlockAlign * BufSize;
  hBuf:= GlobalAlloc(GMEM_MOVEABLE and GMEM_SHARE, BufLen);
  Buf:= GlobalLock(hBuf);
  with BufHead1 do begin
   lpData:= Buf;
   dwBufferLength:= BufLen;
   dwFlags:= 0;
  end;
  with BufHead2 do begin
   lpData:= Buf;
   dwBufferLength:= BufLen;
   dwFlags:= 0;
  end;
  adr2:= @BufHead1;
  waveInPrepareHeader(hwi2, Addr(BufHead1), sizeof(BufHead1));
  waveInPrepareHeader(hwi2, Addr(BufHead2), sizeof(BufHead2));
  WaveInAddBuffer(hwi2, addr(BufHead1), sizeof(BufHead1));
  GetMem(pnt, BufSize * sizeof(TPoint));
  WaveInStart(hwi2);
 //
 end else begin
  //vis_ir.Visible:=false; vis_ir.Hint:= '';
  //
  WaveInReset(hwi2);
  WaveInUnPrepareHeader(hwi2, addr(BufHead1), sizeof(BufHead1));
  WaveInClose(hwi2);
  GlobalUnlock(hBuf); GlobalFree(hBuf);
  FreeMem(pnt, BufSize * sizeof(TPoint));
 end; except end
end;
//=============


{//=============
//  mp3-
procedure twr.ProcessBuffer(uMsg : Word; P : Pointer; n:integer;dwParam1: dword);
var done,len: DWORD;
begin
 case umsg of
  MM_WIM_OPEN:
   begin
    FillChar(BeConfig,SizeOf(BeConfig),#0);
    With BeConfig.Format do begin
     dwConfig := BE_CONFIG_MP3;
     mp3.dwSampleRate := 44100;
     mp3.byMode := BE_MP3_MODE_STEREO;
     mp3.wBitrate := 32;
     mp3.bPrivate := False;
     mp3.bCRC     := False;
     mp3.bCopyright := False;
     mp3.bOriginal := False;
    end;
    BeInitStream(BeConfig, NumSamples, Mp3BufferSize, BladeHandle);
    GetMem(Mp3Buffer, mp3BufferSize);
    hFile:= CreateFile(pchar(WaveRecorder.name), GENERIC_WRITE, 0, nil, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
   end;
  MM_WIM_CLOSE:
   begin
    beDeinitStream(BladeHandle, mp3Buffer, dwWrite);
    WriteFile(hFile, mp3buffer^, dwWrite, skolko, nil);
    beCloseStream(BladeHandle);
    FreeMem(Mp3Buffer);
    CloseHandle(hFile);
   end;
  MM_WIM_DATA:
   begin
    done:= 0;
    len:= pWAVEHDR(dwParam1).dwBytesRecorded;
    while done < len do
     begin
      if (done + NumSamples * 2) < len
       then toRead := NumSamples * 2
        else toRead := len - done;
      beEncodeChunk(BladeHandle, toRead div 2, @pWAVEHDR(dwParam1).lpData[done], mp3Buffer, toWrite);
      WriteFile(hFile, mp3buffer^, toWrite, skolko, nil);
      done:= Done + ToRead;
      //-
      n2:=n2+skolko;
      sz:=round(n2/1024);
     end;
   end
 end
end;

procedure inirec2(f:string;rate: integer;chan,bits: smallint);
begin
 stp3:= not stp3;
 //
 if stp3 then begin
  n2:=0;
  WaveRecorder:= TWR.Create(65536, 4);
  WaveRecorder.name:= f;
  WaveRecorder.pWaveFmtEx.wFormatTag:= WAVE_FORMAT_PCM;
  WaveRecorder.pWaveFmtEx.nChannels := chan;
  WaveRecorder.pWaveFmtEx.nSamplesPerSec := rate;
  WaveRecorder.pWaveFmtEx.wBitsPerSample := bits;
  WaveRecorder.pWaveFmtEx.nAvgBytesPerSec:= WaveRecorder.pWaveFmtEx.nSamplesPerSec*(WaveRecorder.pWaveFmtEx.wBitsPerSample div 8)*WaveRecorder.pWaveFmtEx.nChannels;
  WaveRecorder.SetupRecord(@WaveRecorder);
  //-
  WaveRecorder.StartRecord;
 end else begin
  WaveRecorder.StopRecord;
  WaveRecorder.Destroy
 end
end;
//======================
 }
{// wav mp3-
procedure encwavmp3(wavname,mp3name:string);

 //-
 function GetFileSize(namefile:string):Integer;
 var InfoFile: TSearchRec;
     AttrFile: Integer;
     ErrorReturn: Integer;
 begin
  AttrFile := $0000003F;
  ErrorReturn:= FindFirst(namefile, AttrFile, InfoFile);
  if ErrorReturn <> 0 then Result:= -1
  else Result:= InfoFile.Size;
  FindClose(InfoFile)
 end;

var done,len: DWORD;
begin
 //init-
 FillChar(BeConfig,SizeOf(BeConfig),#0);
 With BeConfig.Format do begin
  dwConfig := BE_CONFIG_MP3;
  mp3.dwSampleRate:= 44100;
  mp3.byMode:= BE_MP3_MODE_STEREO;
  mp3.wBitrate:= 32;
  mp3.bPrivate  := False;
  mp3.bCRC      := False;
  mp3.bCopyright:= False;
  mp3.bOriginal := False;
 end;
 BeInitStream(BeConfig, NumSamples, Mp3BufferSize, BladeHandle);
 GetMem(Mp3Buffer, mp3BufferSize);
 hFile:= CreateFile(pchar(mp3name), GENERIC_WRITE, 0, nil, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);

 //data-
 done:= 0;
 len:= GetFileSize(wavname);
 while done < len do begin
  if (done + NumSamples * 2) < len then toRead:= NumSamples * 2
   else toRead := len - done;
  beEncodeChunk(BladeHandle, toRead div 2, @pWAVEHDR(dwParam1).lpData[done], mp3Buffer, toWrite);
  WriteFile(hFile, mp3buffer^, toWrite, skolko, nil);
  done:= Done + ToRead;
 end;

 //
 i:= 0;
 error:= beInitStream(beConfig, dwSamples, dwSamplesMP3, hbeStream);
 if error = BE_ERR_SUCCESSFUL then begin
  pBuffer:= AllocMem(dwSamples*2);
  pMP3Buffer:= AllocMem(dwSamplesMP3);
  try
   done:= 0;
   error:= FileSeek(fs, 0, 0);
   While (done < TotalSize) do
    begin
     if (done + dwSamples*2 < TotalSize) then ToRead := dwSamples*2
      else begin
       ToRead := TotalSize-done;
       FillChar(pbuffer^,dwSamples,0);
      end;
     if FileRead(fs, pbuffer^, toread) = -1
      then raise Exception.Create(' !');

     error:= beEncodeChunk(hbeStream, toRead div 2, pBuffer^, pMP3Buffer^, toWrite);
     if error <> BE_ERR_SUCCESSFUL then begin
      beCloseStream(hbeStream);
      raise Exception.Create(' !');
     end;

     if FileWrite(hFile, pMP3Buffer^, toWrite) = -1 then raise Exception.Create(' !');
     done:= done + toread;
     inc(i);
     if i mod 64 = 0 then begin
      pgr:= round(100*done/Totalsize);
      Application.ProcessMessages;
     end;
    end;

  error:= beDeInitStream(hbeStream, pMP3Buffer^, dwWrite);
  if error <> BE_ERR_SUCCESSFUL then begin
   beCloseStream(hbeStream);
   raise Exception.Create('  !');
  end;

  if dwWrite <> 0 then begin
   if FileWrite(hFile, pMP3Buffer^, dwWrite) = -1 then raise Exception.Create('  !');
  end;

  beCloseStream(hbeStream);
  finally FreeMem(pBuffer);FreeMem(pMP3Buffer);end; 
 end;

 //free-
 beDeinitStream(BladeHandle, mp3Buffer, dwWrite);
 WriteFile(hFile, mp3buffer^, dwWrite, skolko, nil);
 beCloseStream(BladeHandle);
 FreeMem(Mp3Buffer);
 CloseHandle(hFile)
end;
//======================}

end.
