//------------------------------------------
//SrnCap
// 
//Author:   
//E-mail: amon@ngs.ru
//C : -
//------------------------------------------

unit ScrnCap;

interface
 uses WinProcs,Classes,graphics,Controls;


 procedure InvertBitmap(Bitmap: TBitmap);
 procedure Emboss(ABitmap: TBitmap; AMount: Integer);
 procedure RotateBitmap(Bitmap: TBitmap; Angle: Double; bg: TColor);
 procedure Sharpen(tbm: TBitmap; alpha: Single);
 procedure MixBMP(BM1, BM2: TBitMap; var BM: TBitMap);
 procedure BlackWhite(image: tbitmap; gray: boolean);
 //
 function getmove(b1,b2: TBitmap): integer;
 procedure CaptureClientImage(h: hwnd; b: tbitmap);

implementation

//--- 
type PByteArray = ^TByteArray;
     TByteArray = array[0..32767] of Byte;
procedure InvertBitmap(Bitmap: TBitmap);
var x, y: Integer;
    ByteArray: PByteArray;
begin
 Bitmap.PixelFormat:= pf24bit;
 for y:= 0 to Bitmap.Height - 1 do begin
  ByteArray:= Bitmap.ScanLine[y];
  for x:= 0 to Bitmap.Width * 3 - 1 do
   ByteArray[x] := 255 - ByteArray[x]
 end
end;
//---

//--- 
procedure Emboss(ABitmap: TBitmap; AMount: Integer);
var x, y, i : integer;
    p1, p2: PByteArray;
begin
 ABitmap.PixelFormat:= pf24bit;
 for i:= 0 to AMount do begin
  for y:= 0 to ABitmap.Height-2 do begin
   p1:= ABitmap.ScanLine[y];
   p2:= ABitmap.ScanLine[y+1];
   for x:= 0 to ABitmap.Width do begin
    p1[x*3]  := (p1[x*3]+(p2[(x+3)*3] xor $FF)) shr 1;
    p1[x*3+1]:= (p1[x*3+1]+(p2[(x+3)*3+1] xor $FF)) shr 1;
    p1[x*3+2]:= (p1[x*3+1]+(p2[(x+3)*3+1] xor $FF)) shr 1
   end
  end
 end
end;
//---

//--- 
procedure RotateBitmap(Bitmap: TBitmap; Angle: Double; bg: TColor);
type TRGB = record
       B, G, R: Byte;
     end;
     pRGB = ^TRGB;
     pByteArray = ^TByteArray;
     TByteArray = array[0..32767] of Byte;
     TRectList = array [1..4] of TPoint;

var x, y, W, H, v1, v2: Integer;
    Dest, Src: pRGB;
    VertArray: array of pByteArray;
    Bmp: TBitmap;

  procedure SinCos(AngleRad: Double; var ASin, ACos: Double);
  begin
    ASin := Sin(AngleRad);
    ACos := Cos(AngleRad);
  end;

  function RotateRect(const Rect: TRect; const Center: TPoint; Angle: Double): TRectList;
  var DX, DY: Integer;
      SinAng, CosAng: Double;
    function RotPoint(PX, PY: Integer): TPoint;
    begin
      DX := PX - Center.x;
      DY := PY - Center.y;
      Result.x := Center.x + Round(DX * CosAng - DY * SinAng);
      Result.y := Center.y + Round(DX * SinAng + DY * CosAng);
    end;
  begin
    SinCos(Angle * (Pi / 180), SinAng, CosAng);
    Result[1] := RotPoint(Rect.Left, Rect.Top);
    Result[2] := RotPoint(Rect.Right, Rect.Top);
    Result[3] := RotPoint(Rect.Right, Rect.Bottom);
    Result[4] := RotPoint(Rect.Left, Rect.Bottom);
  end;

  function Min(A, B: Integer): Integer;
  begin
    if A < B then Result := A
             else Result := B;
  end;

  function Max(A, B: Integer): Integer;
  begin
    if A > B then Result := A
             else Result := B;
  end;

  function GetRLLimit(const RL: TRectList): TRect;
  begin
    Result.Left := Min(Min(RL[1].x, RL[2].x), Min(RL[3].x, RL[4].x));
    Result.Top := Min(Min(RL[1].y, RL[2].y), Min(RL[3].y, RL[4].y));
    Result.Right := Max(Max(RL[1].x, RL[2].x), Max(RL[3].x, RL[4].x));
    Result.Bottom := Max(Max(RL[1].y, RL[2].y), Max(RL[3].y, RL[4].y));
  end;

  procedure Rotate;
  var x, y, xr, yr, yp: Integer;
      ACos, ASin: Double;
      Lim: TRect;
  begin
    W := Bmp.Width;
    H := Bmp.Height;
    SinCos(-Angle * Pi/180, ASin, ACos);
    Lim := GetRLLimit(RotateRect(Rect(0, 0, Bmp.Width, Bmp.Height), Point(0, 0), Angle));
    Bitmap.Width := Lim.Right - Lim.Left;
    Bitmap.Height := Lim.Bottom - Lim.Top;
    Bitmap.Canvas.Brush.Color := bg;
    Bitmap.Canvas.FillRect(Rect(0, 0, Bitmap.Width, Bitmap.Height));
    for y := 0 to Bitmap.Height - 1 do begin
      Dest := Bitmap.ScanLine[y];
      yp := y + Lim.Top;
      for x := 0 to Bitmap.Width - 1 do begin
        xr := Round(((x + Lim.Left) * ACos) - (yp * ASin));
        yr := Round(((x + Lim.Left) * ASin) + (yp * ACos));
        if (xr > -1) and (xr < W) and (yr > -1) and (yr < H) then begin
          Src := Bmp.ScanLine[yr];
          Inc(Src, xr);
          Dest^ := Src^;
        end;
        Inc(Dest);
      end;
    end;
  end;

begin
  Bitmap.PixelFormat := pf24Bit;
  Bmp := TBitmap.Create;
  try
    Bmp.Assign(Bitmap);
    W := Bitmap.Width - 1;
    H := Bitmap.Height - 1;
    if Frac(Angle) <> 0.0
      then Rotate
      else
    case Trunc(Angle) of
      -360, 0, 360, 720: Exit;
      90, 270: begin
        Bitmap.Width := H + 1;
        Bitmap.Height := W + 1;
        SetLength(VertArray, H + 1);
        v1 := 0;
        v2 := 0;
        if Angle = 90.0 then v1 := H
                        else v2 := W;
        for y := 0 to H do VertArray[y] := Bmp.ScanLine[Abs(v1 - y)];
        for x := 0 to W do begin
          Dest := Bitmap.ScanLine[x];
          for y := 0 to H do begin
            v1 := Abs(v2 - x)*3;
            with Dest^ do begin
              B := VertArray[y, v1];
              G := VertArray[y, v1+1];
              R := VertArray[y, v1+2];
            end;
            Inc(Dest);
          end;
        end
      end;
      180: begin
        for y := 0 to H do begin
          Dest := Bitmap.ScanLine[y];
          Src := Bmp.ScanLine[H - y];
          Inc(Src, W);
          for x := 0 to W do begin
            Dest^ := Src^;
            Dec(Src);
            Inc(Dest);
          end;
        end;
      end;
      else Rotate;
    end;
  finally
    Bmp.Free;
  end;
end;
//---

//--- 
procedure Sharpen(tbm: TBitmap; alpha: Single);
//to sharpen, alpha must be >1.
//pixelformat pf24bit 
//sharpens sbm to tbm
var i, j, k: integer;
    sr: array[0..2] of PByte;
    st: array[0..4] of pRGBTriple;
    tr: PByte;
    tt, p: pRGBTriple;
    beta: Single;
    inta, intb: integer;
    bmh, bmw: integer;
    re, gr, bl: integer;
    BytesPerScanline: integer;
begin
 tbm.PixelFormat:= pf24bit;
 //
 beta:= (alpha - 1) / 5; //we assume alpha>1 and beta<1
 intb:= round(beta * $10000);
 inta := round(alpha * $10000); //integer scaled alpha and beta

 bmw:= tbm.Width - 2;
 bmh:= tbm.Height - 2;
 BytesPerScanline:= (((bmw + 2) * 24 + 31) and not 31) div 8;
 tr:= tbm.Scanline[0];
 tt:= pRGBTriple(tr);
 sr[0]:= tbm.Scanline[0];
 st[0]:= pRGBTriple(sr[0]);
 for j := 0 to bmw + 1 do begin
  tt^ := st[0]^;
  inc(tt); inc(st[0]); //first row unchanged
 end;
 sr[1] := PByte(integer(sr[0]) - BytesPerScanline);
 sr[2] := PByte(integer(sr[1]) - BytesPerScanline);
 for i := 1 to bmh do begin
  Dec(tr, BytesPerScanline);
  tt   := pRGBTriple(tr);
  st[0]:= pRGBTriple(integer(sr[0]) + 3); //top
  st[1]:= pRGBTriple(sr[1]); //left
  st[2]:= pRGBTriple(integer(sr[1]) + 3); //center
  st[3]:= pRGBTriple(integer(sr[1]) + 6); //right
  st[4]:= pRGBTriple(integer(sr[2]) + 3); //bottom
  tt^  := st[1]^; //1st col unchanged
  for j := 1 to bmw do begin
   //calcutate average weighted by -beta
   re:= 0; gr := 0; bl := 0;
   for k:= 0 to 4 do begin
    re:= re + st[k]^.rgbtRed;
    gr:= gr + st[k]^.rgbtGreen;
    bl:= bl + st[k]^.rgbtBlue;
    inc(st[k])
   end;
   re:= (intb * re + $7FFF) shr 16;
   gr:= (intb * gr + $7FFF) shr 16;
   bl:= (intb * bl + $7FFF) shr 16;
   //add center pixel weighted by alpha
   p := pRGBTriple(st[1]); //after inc, st[1] is at center
   re:= (inta * p^.rgbtRed + $7FFF) shr 16 - re;
   gr:= (inta * p^.rgbtGreen + $7FFF) shr 16 - gr;
   bl:= (inta * p^.rgbtBlue + $7FFF) shr 16 - bl;
   //clamp and move into target pixel
   inc(tt);
   if re < 0 then re:= 0
    else if re > 255 then re:= 255;
   if gr < 0 then gr:= 0
    else if gr > 255 then gr:= 255;
     if bl < 0 then bl:= 0
      else if bl > 255 then bl:= 255;
    //this looks stupid, but avoids function calls
    tt^.rgbtRed := re;
    tt^.rgbtGreen := gr;
    tt^.rgbtBlue := bl;
   end;
   inc(tt);
   inc(st[1]);
   tt^ := st[1]^; //Last col unchanged
   sr[0] := sr[1];
   sr[1] := sr[2];
   Dec(sr[2], BytesPerScanline);
  end;
  // copy last row
  Dec(tr, BytesPerScanline);
  tt   := pRGBTriple(tr);
  st[1]:= pRGBTriple(sr[1]);
  for j:= 0 to bmw + 1 do begin
   tt^ := st[1]^;
   inc(tt); inc(st[1])
  end
end;
//---

//--- 
procedure MixBMP(BM1, BM2: TBitMap; var BM: TBitMap);
var i,J,MinW,MinH: Integer;
begin
 BM:= TBitMap.Create;
 if BM1.Width < BM2.Width then MinW:= BM1.Width
  else MinW:= BM2.Width;
 if BM1.Height < BM2.Height then MinH:= BM1.Height
  else minH:= BM2.Height;

 BM.Width := MinW;
 BM.Height:= MinH;
 for I := 0 to MinW do
    for J := 0 to MinH do
      if (Odd(I) and Odd(J)) or ((not (Odd(I))) and (not (Odd(J)))) then
        BM.Canvas.Pixels[I, J] := BM1.Canvas.Pixels[I, J]
      else
        BM.Canvas.Pixels[I, J] := BM2.Canvas.Pixels[I, J];
end;
//---

//--- 
type
 TRGB=record
 b,g,r : byte;
end;
type
  ARGB=array [0..1] of TRGB;
  PARGB=^ARGB;
procedure BlackWhite(image: tbitmap; gray: boolean);
var i,j,c: integer;
    p: PARGB;
begin
 image.PixelFormat:= pf24bit;
 for i:=0 to image.Height-1 do begin
  p:= image.ScanLine[i];
  for j:= 0 to image.Width-1 do begin
   c:= round(0.3*p[j].r+0.59*p[j].g+0.11*p[j].b);
   if not gray then // 
    if c >= 128 then c:= 255 else c:= 0;
   p[j].r:= c;
   p[j].g:= c;
   p[j].b:= c
  end
 end
end;
//---


//--- c
function getmove(b1,b2: TBitmap): integer;
var c1,c2: PByte;
    x,y,i,t: integer;
begin
 b1.PixelFormat:= pf24bit;
 b2.PixelFormat:= pf24bit;
 t:= 0;
 //
 for y:= 0 to b1.Height - 1 do begin
  c1:= b1.Scanline[y];
  c2:= b2.Scanline[y];
  for x:= 0 to b1.Width - 1 do
   for i:= 0 to 4 - 1 do begin
    Inc(t, Integer(c1^ <> c2^));
    Inc(c1);
    Inc(c2)
   end
 end;
 result:= t
end;
//---

//--- 
procedure CaptureClientImage(h: hwnd; b: tbitmap);
var DC   : hDC;
    Rect : TRect;
    wX,wY: integer;
begin
 GetWindowRect(h,Rect);
 wX:= Rect.Right - Rect.Left;
 wY:= Rect.Bottom - Rect.Top;
 DC:= GetWindowDC(h);
 //
 b.Handle:= CreateCompatibleBitmap(dc,wX,wY);
 BitBlt(b.Canvas.Handle,0,0,wX,wY,dc,0,0,SRCCOPY);
 ReleaseDC(h,DC)
end;


end.